package de.fraunhofer.iem.dataprovider.toolResult

import org.springframework.data.annotation.Id
import org.springframework.data.relational.core.mapping.Table

@Table("TOOL_RESULTS")
data class ToolResultsDb(
    val results: List<ToolResultDb>,
    val tool: ToolDb,
    @Id var id: String? = null
)

data class ToolResultDb(
    val level: String,
    val locations: List<ResultLocationDb>,
    val message: String,
    val ruleId: String,
)

data class ResultLocationDb(
    val artifactLocationUri: String,
    val endColumn: Int,
    val endLine: Int,
    val startColumn: Int,
    val startLine: Int,
)

data class ToolDb(
    val fullName: String,
    val name: String,
    val rules: List<RuleDb>,
    val downloadUri: String? = null,
    val guid: String? = null,
    val informationUri: String? = null,
    val language: String? = null,
    val organization: String? = null,
    val semanticVersion: String? = null,
    val version: String? = null,
)

data class RuleDb(
    val ruleId: String,
    val name: String,
    val shortDescription: String,
    val helpUri: String? = null,
)
